package main

import (
	"archive/zip"
	"io"
	"io/ioutil"
	"fmt"
	"os"
)

func length(f *zip.File) (int64, error) {
	r, err := f.Open()
	if err != nil {
		return 0, err
	}
	defer r.Close()
	return io.Copy(ioutil.Discard, r)
}

func main() {
	z, err := zip.OpenReader(os.Args[1])
	if err != nil {
		panic(err)
	}
	defer z.Close()
	for _, f := range z.File {
		n, err := length(f)
		if err != nil {
			panic(err)
		}
		fmt.Printf("%d\t%s\n", n, f.Name)
	}
}
